/*
		NewMob.cpp : implementation file

        Copyright (C) 2000 Patrick Dughi

        This software may be used and distributed according to the terms
        of the GNU Public License, incorporated herein by reference, located
		as the file gpl.txt in this same directory.

        The author may be reached at dughi@imaxx.net.
.		
		Class corresponding to the dialog of the same name.
*/
#include "stdafx.h"
#include "Cbreak.h"
#include "NewMob.h"
#include "World.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// NewMob dialog


NewMob::NewMob(CWnd* pParent /*=NULL*/)
	: CDialog(NewMob::IDD, pParent)
{
	//{{AFX_DATA_INIT(NewMob)
	m_new_mob_num = 0;
	//}}AFX_DATA_INIT
}


void NewMob::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(NewMob)
	DDX_Text(pDX, IDC_NEW_MOB_NUM, m_new_mob_num);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(NewMob, CDialog)
	//{{AFX_MSG_MAP(NewMob)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// NewMob message handlers

extern World the_world;
extern CCbreakApp theApp;
void NewMob::OnOK() 
{
  Mob *new_mob;
  map<int,Zone_Data>::const_iterator zi;
  int good=0,zone_num;

  UpdateData(TRUE);
  
	/* check if it's already existing */
  if(the_world.mob_list.find(m_new_mob_num)!= the_world.mob_list.end()) {
	  AfxMessageBox("That mob already exists!",MB_OK);
	  return;
  }
  /* check if it's in a zone or not */

  for(zi=the_world.zone_list.begin();zi != the_world.zone_list.end() && !good;zi++) {
    if(m_new_mob_num >= zi->second.number * 100 && m_new_mob_num <= zi->second.top) {
			good=1;
			zone_num = zi->second.number;
		}
  }

  if(!good) {
		AfxMessageBox("That mob would exist outside a zone!",MB_OK);
	  return;
  }

	new_mob = new Mob;
	new_mob->zone = zone_num;
	new_mob->alias = "unfinished mob";
	new_mob->sdesc = "unfinished mob";
	new_mob->ldesc = "an unfinished mob";
	new_mob->number = m_new_mob_num;
	new_mob->level =0;
	new_mob->ac=100;
	new_mob->action=0;
	new_mob->affect=0;
	new_mob->alignment=0;
	new_mob->attack_bonus=0;
	new_mob->attack_dice=1;
	new_mob->attack_size=1;
	new_mob->default_pos=8;
	new_mob->experience=0;
	new_mob->gender=0;
	new_mob->gold=0;
	new_mob->hit_bonus=0;
	new_mob->hit_size=1;
	new_mob->hit_dice=1;
	new_mob->load_pos=8;
	new_mob->thac0=20;

	new_mob->attack_type=0;

	for(good=0;good < NUM_OF_STATS;good++) {
		new_mob->stats[good] = 14;
	}
	new_mob->stats[STAT_STRADD]=0;

	the_world.mob_list[m_new_mob_num] = *new_mob;

	theApp.dlg->current_mob = m_new_mob_num;
	theApp.dlg->m_medit.LoadMedit();
	CDialog::OnOK();
}
