/*
		NewZoneDlg.cpp : implementation file

        Copyright (C) 2000 Patrick Dughi

        This software may be used and distributed according to the terms
        of the GNU Public License, incorporated herein by reference, located
		as the file gpl.txt in this same directory.

        The author may be reached at dughi@imaxx.net.
.		
		Class corresponding to the dialog of the same name.
*/

#pragma warning(disable:4786)
#include "stdafx.h"
#include "Cbreak.h"
#include "NewZoneDlg.h"
#include "utils.h"
#include "DirDialog.h"
#include <list>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CNewZoneDlg dialog


CNewZoneDlg::CNewZoneDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CNewZoneDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CNewZoneDlg)
	m_new_zone_number = 0;
	m_warning = _T("");
	m_top_of_zone = _T("");
	m_lifespan = 0;
	m_new_zone_name = _T("");
	m_zone_reset = -1;
	//}}AFX_DATA_INIT
}


void CNewZoneDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CNewZoneDlg)
	DDX_Control(pDX, IDC_NEW_ZONE_NAME, e_new_zone_name);
	DDX_Text(pDX, IDC_NEW_ZONE, m_new_zone_number);
	DDX_Text(pDX, IDC_NEW_ZONE_WARNING, m_warning);
	DDX_Text(pDX, IDC_TOP_OF_ZONE, m_top_of_zone);
	DDX_Text(pDX, IDC_NEW_ZONE_LIFESPAN, m_lifespan);
	DDX_Text(pDX, IDC_NEW_ZONE_NAME, m_new_zone_name);
	DDX_CBIndex(pDX, IDC_NEW_ZONE_RESET, m_zone_reset);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CNewZoneDlg, CDialog)
	//{{AFX_MSG_MAP(CNewZoneDlg)
	ON_EN_CHANGE(IDC_NEW_ZONE, OnChangeNewZone)
	ON_EN_CHANGE(IDC_NEW_ZONE_LIFESPAN, OnChangeNewZoneLifespan)
	ON_EN_CHANGE(IDC_NEW_ZONE_NAME, OnChangeNewZoneName)
	ON_CBN_EDITCHANGE(IDC_NEW_ZONE_RESET, OnEditchangeNewZoneReset)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNewZoneDlg message handlers

void CNewZoneDlg::OnChangeNewZone() 
{
	char unknown[3000];
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.

	GetDlgItemText(IDC_NEW_ZONE,unknown, 3000);
	// TODO: Add your control notification handler code here
	if(atoi(unknown) <= 326 && atoi(unknown) >= 0) {
	  GetDlgItem(IDC_TOP_OF_ZONE)->SetWindowText(
							  iprintf("%d",(atoi(unknown)*100)+99));
	} else {
  	GetDlgItem(IDC_TOP_OF_ZONE)->SetWindowText("Out of Bounds (0 to 326)");
	}
	UpdateData();
}

extern World the_world;
extern CCbreakApp theApp;

void CNewZoneDlg::OnOK() 
{
	int good=1;
  CircleFile fp;
	Room *new_room;
  map<int,Zone_Data>::const_iterator zrn;
	Zone_Data *zone;
	char text[256];
	string temp;


	if(the_world.zone_list.size()) {    // no zone table means no zones at all!
   	for (zrn = the_world.zone_list.begin(), good=1; 
					zrn != the_world.zone_list.end() && good; zrn++) {
    	if(zrn->first == m_new_zone_number) {
			sprintf(text,"Zone %d (%s) already exists.",m_new_zone_number,zrn->second.name.c_str());
            GetDlgItem(IDC_NEW_ZONE_WARNING)->SetWindowText(text);
	  	return;
        good=0;
			}
		}
    if(!good) {
  	  sprintf(text,"Zone %d (%s) already exists.",m_new_zone_number,zrn->second.name.c_str());
      GetDlgItem(IDC_NEW_ZONE_WARNING)->SetWindowText(text);

	  	return;
		}
	} 
	/*else {
		 it's okay if there are no zones, actually 
		error("No zones, or fish slapped");
		return;
	} */

	// technically, this validation code shouldn't really be needed....
	if(m_lifespan <= 0 || m_lifespan >= 999) {
		sprintf(text,"Lifespan must be between 1 and 998.");
    GetDlgItem(IDC_NEW_ZONE_WARNING)->SetWindowText(text);
		return;
	}


	// we've done all the sanity checking...

  temp = iprintf("%s\\%s\\%d.zon", ourlib.m_strPath, "zon", m_new_zone_number);
  if (!(fp.open_file(temp,1,m_new_zone_number))) {
    error("Could not open new zone file '%s' for writing.",temp.c_str());
		return;
  }
  temp = iprintf("#%d\n%s~\n%d %d %d\nS\n$\n",  m_new_zone_number,m_new_zone_name, 
			(m_new_zone_number *100) + 99, m_lifespan, m_zone_reset);
  fp.write_line(&temp);
  fp.write_line("S\n$\n");
  fp.close_file();



	// replace later with save_room ?

	new_room = new Room;
	new_room->zone = m_new_zone_number;
	new_room->name = "The Beginning";
	new_room->description = "Not Much Here";
	new_room->number = m_new_zone_number * 100;
	
	the_world.room_list[m_new_zone_number*100] = *new_room;

  temp=iprintf("%s\\%s\\%d.wld", ourlib.m_strPath,"wld", m_new_zone_number);
  if (!(fp.open_file(temp,1,m_new_zone_number))) {
    error("Could not open new world file '%s' for writing.",temp.c_str());
		return;
  }
  temp = iprintf("#%d\nThe Beginning~\nNot much here.\n~\n%d 0 0\nS\n$\n",
				m_new_zone_number * 100, m_new_zone_number);
  fp.write_line(&temp);
  fp.close_file();


  temp=iprintf("%s\\%s\\%d.mob", ourlib.m_strPath,"mob", m_new_zone_number);
  if (!(fp.open_file(temp,1,m_new_zone_number))) {
    error("Could not open new Mobile file '%s' for writing.",temp.c_str());
		return;
  }
  fp.write_line("$\n");
  fp.close_file();

  temp=iprintf("%s\\%s\\%d.obj", ourlib.m_strPath,"obj", m_new_zone_number);
  if (!(fp.open_file(temp,1,m_new_zone_number))) {
    error("Could not open new object file '%s' for writing.",temp.c_str());
		return;
  }
  fp.write_line("$\n");
  fp.close_file();;

  temp=iprintf("%s\\%s\\%d.shp", ourlib.m_strPath,"shp", m_new_zone_number);
  if (!(fp.open_file(temp,1,m_new_zone_number))) {
    error("Could not open new shop file '%s' for writing.",temp.c_str());
		return;
  }
  fp.write_line("$~\n");
  fp.close_file();

  zone = new Zone_Data;	
  zone->name = m_new_zone_name;
  zone->number = m_new_zone_number;
  zone->top = (m_new_zone_number * 100) + 99;
  zone->lifespan = m_lifespan;
  zone->reset_mode = m_zone_reset;

	// normally, we'd alloc a new zone_list = sizeof(zone_list +1), then
	// iterate through and assign the old ones, and stick the new one in the
	// correct place, free the orig list, assign the new, reorder everything
	// which uses zone rnums, and then go on with life. (pain in the ass)
	// realize here, we're adding a new zone, not reordering the old ones. 
	// this is pretty neat, if you've seen the original method.

  the_world.zone_list[m_new_zone_number]=*zone;
  
	// heh. time to do a little dance
	
	// update our indexes
	the_world.zon_files.push_back(m_new_zone_number);
	the_world.wld_files.push_back(m_new_zone_number);
	the_world.mob_files.push_back(m_new_zone_number);
	the_world.obj_files.push_back(m_new_zone_number);
	the_world.shp_files.push_back(m_new_zone_number);
  create_world_index();

  theApp.dlg->current_room = m_new_zone_number*100;
	theApp.dlg->m_redit.LoadRedit();
	CDialog::OnOK();
}

BOOL CNewZoneDlg::OnInitDialog() 
{
	// TODO: Add extra initialization here
	m_new_zone_number=0;
	m_new_zone_name = "New zone";
	m_lifespan = 1;
	m_zone_reset=0;

	CDialog::OnInitDialog();
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CNewZoneDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	CDialog::OnCancel();
}

void CNewZoneDlg::OnChangeNewZoneLifespan() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	UpdateData();

}

void CNewZoneDlg::OnChangeNewZoneName() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
		UpdateData();

}

void CNewZoneDlg::OnEditchangeNewZoneReset() 
{
	// TODO: Add your control notification handler code here
	UpdateData();

}

// previously, we had to search the whole index, and add if it did not
// already exist.  This is actually a time consuming and annoying prospect.
// it couldn't be done automagicaly - generated from the existing zones,
// etc.  So, we'll save em when we read em, and write em all when we need em.

bool CNewZoneDlg::create_world_index()
{
  string temp;
  list<int>::const_iterator it,term;
  CircleFile cf;
  int i;
  extern const char *suffix[];
 
  for(i=0;i<NUM_SUFFIX;i++) {

    switch(i) {
  	  case ZON_SUF:
				the_world.zon_files.sort();
				the_world.zon_files.unique();
				it=the_world.zon_files.begin();
				term=the_world.zon_files.end();
				break;
			case WLD_SUF:
				the_world.wld_files.sort();
				the_world.wld_files.unique();
				it=the_world.wld_files.begin();
				term=the_world.wld_files.end();
				break;
			case MOB_SUF:
				the_world.mob_files.sort();
				the_world.mob_files.unique();
				it=the_world.mob_files.begin();
				term=the_world.mob_files.end();
				break;
			case OBJ_SUF:
				the_world.obj_files.sort();
				the_world.obj_files.unique();
				it=the_world.obj_files.begin();
				term=the_world.obj_files.end();
				break;
			case SHP_SUF:
				the_world.shp_files.sort();
				the_world.shp_files.unique();
				it=the_world.shp_files.begin();
				term=the_world.shp_files.end();
				break;
      default:
				error("Nutbunnies. Better to die than live a life without honor.");
				break;
		}  
    temp = iprintf("%s\\%s\\index",ourlib.m_strPath,suffix[i]);
	  cf.open_file(temp,1,0);
		while(it != term) {
			cf.write_line(iprintf("%d.%s\n",*it,suffix[i]));
      it++;
		}
		cf.write_line("$\n");
		cf.close_file();
  }
	return TRUE;
}
